pcl::Poisson< PointNT > Class Template Reference
Module surface

The Poisson surface reconstruction algorithm. More...

`#include <pcl/surface/poisson.h>`

Inheritance diagram for pcl::Poisson< PointNT >:

## Public Types

typedef boost::shared_ptr< Poisson< PointNT > > | Ptr
typedef boost::shared_ptr< const Poisson< PointNT > > | ConstPtr
typedef pcl::PointCloud< PointNT >::Ptr | PointCloudPtr
typedef pcl::KdTree< PointNT > | KdTree
typedef pcl::KdTree< PointNT >::Ptr | KdTreePtr
Public Types inherited from pcl::SurfaceReconstruction< PointNT >
typedef boost::shared_ptr< SurfaceReconstruction< PointNT > > | Ptr
typedef boost::shared_ptr< const SurfaceReconstruction< PointNT > > | ConstPtr
Public Types inherited from pcl::PCLSurfaceBase< PointNT >
typedef boost::shared_ptr< PCLSurfaceBase< PointNT > > | Ptr
typedef boost::shared_ptr< const PCLSurfaceBase< PointNT > > | ConstPtr
typedef pcl::search::Search< PointNT > | KdTree
typedef pcl::search::Search< PointNT >::Ptr | KdTreePtr
Public Types inherited from pcl::PCLBase< PointNT >
typedef pcl::PointCloud< PointNT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| Poisson ()
| Constructor that sets all the parameters to working default values. More...
| ~Poisson ()
| Destructor. More...
void | performReconstruction (pcl::PolygonMesh &output)
| Create the surface. More...
void | performReconstruction (pcl::PointCloud< PointNT > &points, std::vector< pcl::Vertices > &polygons)
| Create the surface. More...
void | setDepth (int depth)
| Set the maximum depth of the tree that will be used for surface reconstruction. More...
int | getDepth ()
| Get the depth parameter. More...
void | setMinDepth (int min_depth)
int | getMinDepth ()
void | setPointWeight (float point_weight)
float | getPointWeight ()
void | setScale (float scale)
| Set the ratio between the diameter of the cube used for reconstruction and the diameter of the samples' bounding cube. More...
float | getScale ()
| Get the ratio between the diameter of the cube used for reconstruction and the diameter of the samples' bounding cube. More...
void | setSolverDivide (int solver_divide)
| Set the the depth at which a block Gauss-Seidel solver is used to solve the Laplacian equation. More...
int | getSolverDivide ()
| Get the the depth at which a block Gauss-Seidel solver is used to solve the Laplacian equation. More...
void | setIsoDivide (int iso_divide)
| Set the depth at which a block iso-surface extractor should be used to extract the iso-surface. More...
int | getIsoDivide ()
| Get the depth at which a block iso-surface extractor should be used to extract the iso-surface. More...
void | setSamplesPerNode (float samples_per_node)
| Set the minimum number of sample points that should fall within an octree node as the octree construction is adapted to sampling density. More...
float | getSamplesPerNode ()
| Get the minimum number of sample points that should fall within an octree node as the octree construction is adapted to sampling density. More...
void | setConfidence (bool confidence)
| Set the confidence flag. More...
bool | getConfidence ()
| Get the confidence flag. More...
void | setOutputPolygons (bool output_polygons)
| Enabling this flag tells the reconstructor to output a polygon mesh (rather than triangulating the results of Marching Cubes). More...
bool | getOutputPolygons ()
| Get whether the algorithm outputs a polygon mesh or a triangle mesh. More...
void | setDegree (int degree)
| Set the degree parameter. More...
int | getDegree ()
| Get the degree parameter. More...
void | setManifold (bool manifold)
| Set the manifold flag. More...
bool | getManifold ()
| Get the manifold flag. More...
Public Member Functions inherited from pcl::SurfaceReconstruction< PointNT >
| SurfaceReconstruction ()
| Constructor. More...
virtual | ~SurfaceReconstruction ()
| Destructor. More...
virtual void | reconstruct (pcl::PolygonMesh &output)
| Base method for surface reconstruction for all points given in <setInputCloud (), setIndices ()> More...
virtual void | reconstruct (pcl::PointCloud< PointNT > &points, std::vector< pcl::Vertices > &polygons)
| Base method for surface reconstruction for all points given in <setInputCloud (), setIndices ()> More...
Public Member Functions inherited from pcl::PCLSurfaceBase< PointNT >
| PCLSurfaceBase ()
| Empty constructor. More...
virtual | ~PCLSurfaceBase ()
| Empty destructor. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide an optional pointer to a search object. More...
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used. More...
Public Member Functions inherited from pcl::PCLBase< PointNT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointNT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

std::string | getClassName () const
| Class get name method. More...
Protected Member Functions inherited from pcl::PCLBase< PointNT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::SurfaceReconstruction< PointNT >
bool | check_tree_
| A flag specifying whether or not the derived reconstruction algorithm needs the search object tree. More...
Protected Attributes inherited from pcl::PCLSurfaceBase< PointNT >
KdTreePtr | tree_
| A pointer to the spatial search object. More...
Protected Attributes inherited from pcl::PCLBase< PointNT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointNT>
class pcl::Poisson< PointNT >

The Poisson surface reconstruction algorithm.

Note
  Code adapted from Misha Kazhdan: http://www.cs.jhu.edu/~misha/Code/PoissonRecon/
  Based on the paper:
  - Michael Kazhdan, Matthew Bolitho, Hugues Hoppe, "Poisson surface reconstruction", SGP '06 Proceedings of the fourth Eurographics symposium on Geometry processing

Author
  Alexandru-Eugen Ichim

Definition at line 60 of file poisson.h.

## Member Typedef Documentation

template<typename PointNT >

typedef boost::shared_ptr<const Poisson<PointNT> > pcl::Poisson< PointNT >::ConstPtr

Definition at line 64 of file poisson.h.

template<typename PointNT >

typedef pcl::KdTree<PointNT> pcl::Poisson< PointNT >::KdTree

Definition at line 71 of file poisson.h.

template<typename PointNT >

typedef pcl::KdTree<PointNT>::Ptr pcl::Poisson< PointNT >::KdTreePtr

Definition at line 72 of file poisson.h.

template<typename PointNT >

typedef pcl::PointCloud<PointNT>::Ptr pcl::Poisson< PointNT >::PointCloudPtr

Definition at line 69 of file poisson.h.

template<typename PointNT >

typedef boost::shared_ptr<Poisson<PointNT> > pcl::Poisson< PointNT >::Ptr

Definition at line 63 of file poisson.h.

## Constructor & Destructor Documentation

template<typename PointNT >

pcl::Poisson< PointNT >::Poisson | ( |  | ) |

Constructor that sets all the parameters to working default values.

Definition at line 64 of file poisson.hpp.

template<typename PointNT >

pcl::Poisson< PointNT >::~Poisson | ( |  | ) |

Destructor.

Definition at line 89 of file poisson.hpp.

References pcl::poisson::Octree< Degree >::ClipTree(), pcl::poisson::Point3D< Real >::coords, pcl::poisson::Octree< Degree >::finalize(), pcl::poisson::Octree< Degree >::GetIsoValue(), pcl::PCLBase< PointNT >::input_, pcl::poisson::Octree< Degree >::LaplacianMatrixIteration(), pcl::poisson::Octree< Degree >::maxMemoryUsage, pcl::poisson::Octree< Degree >::RefineBoundary(), pcl::poisson::OctNode< class TreeNodeData, Real >::SetAllocator(), pcl::poisson::Octree< Degree >::setBSplineData(), pcl::poisson::Octree< Degree >::SetLaplacianConstraints(), pcl::poisson::Octree< Degree >::setTree(), pcl::poisson::Octree< Degree >::tree, and pcl::poisson::TreeNodeData::UseIndex.

## Member Function Documentation

template<typename PointNT >

std::string pcl::Poisson< PointNT >::getClassName | ( |  | ) | const

inline protected virtual

Class get name method.

Reimplemented from pcl::PCLSurfaceBase< PointNT >.

Definition at line 221 of file poisson.h.

template<typename PointNT >

bool pcl::Poisson< PointNT >::getConfidence | ( |  | ) |

inline

Get the confidence flag.

Definition at line 183 of file poisson.h.

template<typename PointNT >

int pcl::Poisson< PointNT >::getDegree | ( |  | ) |

inline

Get the degree parameter.

Definition at line 204 of file poisson.h.

template<typename PointNT >

int pcl::Poisson< PointNT >::getDepth | ( |  | ) |

inline

Get the depth parameter.

Definition at line 105 of file poisson.h.

template<typename PointNT >

int pcl::Poisson< PointNT >::getIsoDivide | ( |  | ) |

inline

Get the depth at which a block iso-surface extractor should be used to extract the iso-surface.

Definition at line 156 of file poisson.h.

template<typename PointNT >

bool pcl::Poisson< PointNT >::getManifold | ( |  | ) |

inline

Get the manifold flag.

Definition at line 216 of file poisson.h.

template<typename PointNT >

int pcl::Poisson< PointNT >::getMinDepth | ( |  | ) |

inline

Definition at line 111 of file poisson.h.

template<typename PointNT >

bool pcl::Poisson< PointNT >::getOutputPolygons | ( |  | ) |

inline

Get whether the algorithm outputs a polygon mesh or a triangle mesh.

Definition at line 194 of file poisson.h.

template<typename PointNT >

float pcl::Poisson< PointNT >::getPointWeight | ( |  | ) |

inline

Definition at line 117 of file poisson.h.

template<typename PointNT >

float pcl::Poisson< PointNT >::getSamplesPerNode | ( |  | ) |

inline

Get the minimum number of sample points that should fall within an octree node as the octree construction is adapted to sampling density.

Definition at line 171 of file poisson.h.

template<typename PointNT >

float pcl::Poisson< PointNT >::getScale | ( |  | ) |

inline

Get the ratio between the diameter of the cube used for reconstruction and the diameter of the samples' bounding cube.

Definition at line 130 of file poisson.h.

template<typename PointNT >

int pcl::Poisson< PointNT >::getSolverDivide | ( |  | ) |

inline

Get the the depth at which a block Gauss-Seidel solver is used to solve the Laplacian equation.

Definition at line 143 of file poisson.h.

template<typename PointNT >

void pcl::Poisson< PointNT >::performReconstruction | ( | pcl::PolygonMesh & | output | ) |

virtual

Create the surface.

Parameters

  [out] | output | the resultant polygonal mesh

Implements pcl::SurfaceReconstruction< PointNT >.

Definition at line 152 of file poisson.hpp.

References pcl::PolygonMesh::cloud, pcl::poisson::Point3D< Real >::coords, pcl::poisson::CoredMeshData::inCorePoints, pcl::poisson::CoredVectorMeshData::nextOutOfCorePoint(), pcl::poisson::CoredVectorMeshData::nextPolygon(), pcl::poisson::CoredVectorMeshData::outOfCorePointCount(), pcl::PointCloud< PointT >::points, pcl::poisson::CoredVectorMeshData::polygonCount(), pcl::PolygonMesh::polygons, pcl::toPCLPointCloud2(), and pcl::Vertices::vertices.

template<typename PointNT >

void pcl::Poisson< PointNT >::performReconstruction | ( | pcl::PointCloud< PointNT > & | points,
|  | std::vector< pcl::Vertices > & | polygons
| ) |  |

virtual

Create the surface.

Parameters

  [out] | points | the vertex positions of the resulting mesh
  [out] | polygons | the connectivity of the resulting mesh

Implements pcl::SurfaceReconstruction< PointNT >.

Definition at line 232 of file poisson.hpp.

References pcl::poisson::Point3D< Real >::coords, pcl::poisson::CoredMeshData::inCorePoints, pcl::poisson::CoredVectorMeshData::nextOutOfCorePoint(), pcl::poisson::CoredVectorMeshData::nextPolygon(), pcl::poisson::CoredVectorMeshData::outOfCorePointCount(), pcl::PointCloud< PointT >::points, pcl::poisson::CoredVectorMeshData::polygonCount(), pcl::PointCloud< PointT >::resize(), and pcl::Vertices::vertices.

template<typename PointNT >

void pcl::Poisson< PointNT >::setConfidence | ( | bool | confidence | ) |

inline

Set the confidence flag.

Note
  Enabling this flag tells the reconstructor to use the size of the normals as confidence information. When the flag is not enabled, all normals are normalized to have unit-length prior to reconstruction.

Parameters

  [in] | confidence | the given flag

Definition at line 179 of file poisson.h.

template<typename PointNT >

void pcl::Poisson< PointNT >::setDegree | ( | int | degree | ) |

inline

Set the degree parameter.

Parameters

  [in] | degree | the given degree

Definition at line 200 of file poisson.h.

template<typename PointNT >

void pcl::Poisson< PointNT >::setDepth | ( | int | depth | ) |

inline

Set the maximum depth of the tree that will be used for surface reconstruction.

Note
  Running at depth d corresponds to solving on a voxel grid whose resolution is no larger than 2^d x 2^d x 2^d. Note that since the reconstructor adapts the octree to the sampling density, the specified reconstruction depth is only an upper bound.

Parameters

  [in] | depth | the depth parameter

Definition at line 101 of file poisson.h.

template<typename PointNT >

void pcl::Poisson< PointNT >::setIsoDivide | ( | int | iso_divide | ) |

inline

Set the depth at which a block iso-surface extractor should be used to extract the iso-surface.

Note
  Using this parameter helps reduce the memory overhead at the cost of a small increase in extraction time. (In practice, we have found that for reconstructions of depth 9 or higher a subdivide depth of 7 or 8 can greatly reduce the memory usage.)

Parameters

  [in] | iso_divide | the given parameter value

Definition at line 152 of file poisson.h.

template<typename PointNT >

void pcl::Poisson< PointNT >::setManifold | ( | bool | manifold | ) |

inline

Set the manifold flag.

Note
  Enabling this flag tells the reconstructor to add the polygon barycenter when triangulating polygons with more than three vertices.

Parameters

  [in] | manifold | the given flag

Definition at line 212 of file poisson.h.

template<typename PointNT >

void pcl::Poisson< PointNT >::setMinDepth | ( | int | min_depth | ) |

inline

Definition at line 108 of file poisson.h.

template<typename PointNT >

void pcl::Poisson< PointNT >::setOutputPolygons | ( | bool | output_polygons | ) |

inline

Enabling this flag tells the reconstructor to output a polygon mesh (rather than triangulating the results of Marching Cubes).

Parameters

  [in] | output_polygons | the given flag

Definition at line 190 of file poisson.h.

template<typename PointNT >

void pcl::Poisson< PointNT >::setPointWeight | ( | float | point_weight | ) |

inline

Definition at line 114 of file poisson.h.

template<typename PointNT >

void pcl::Poisson< PointNT >::setSamplesPerNode | ( | float | samples_per_node | ) |

inline

Set the minimum number of sample points that should fall within an octree node as the octree construction is adapted to sampling density.

Note
  For noise-free samples, small values in the range [1.0 - 5.0] can be used. For more noisy samples, larger values in the range [15.0 - 20.0] may be needed to provide a smoother, noise-reduced, reconstruction.

Parameters

  [in] | samples_per_node | the given parameter value

Definition at line 165 of file poisson.h.

template<typename PointNT >

void pcl::Poisson< PointNT >::setScale | ( | float | scale | ) |

inline

Set the ratio between the diameter of the cube used for reconstruction and the diameter of the samples' bounding cube.

Parameters

  [in] | scale | the given parameter value

Definition at line 124 of file poisson.h.

template<typename PointNT >

void pcl::Poisson< PointNT >::setSolverDivide | ( | int | solver_divide | ) |

inline

Set the the depth at which a block Gauss-Seidel solver is used to solve the Laplacian equation.

Note
  Using this parameter helps reduce the memory overhead at the cost of a small increase in reconstruction time. (In practice, we have found that for reconstructions of depth 9 or higher a subdivide depth of 7 or 8 can greatly reduce the memory usage.)

Parameters

  [in] | solver_divide | the given parameter value

Definition at line 139 of file poisson.h.

The documentation for this class was generated from the following files:

- /build/pcl-6_P28C/pcl-1.7.2/surface/include/pcl/surface/poisson.h
- /build/pcl-6_P28C/pcl-1.7.2/surface/include/pcl/surface/impl/poisson.hpp